package org.spagic3.components.bpm.handler.loop;

import org.jbpm.graph.exe.ExecutionContext;

public class AggregatorPartsHandler extends AbstractBaseLoopHandler {

	@Override
	public void execute(ExecutionContext executionContext) throws Exception {
		
		org.jbpm.graph.exe.ProcessInstance pi = executionContext.getToken().getProcessInstance();
		int size =  (Integer)getVariable(executionContext, pi, getLastIndexVariableName());
		
		
		StringBuffer sb = new StringBuffer();
		sb.append("<"+getAggregatorTag()+">\n");
		for (int i =0; i < size; i++){
			String part = (String)getVariable(executionContext, pi, getPartIVariableName(i));
			sb.append(part);
		}
		sb.append("</"+getAggregatorTag()+">\n");
		
		
		for (int i =0; i < size; i++){
			deleteVariable(executionContext, pi, getPartIVariableName(i));
		}
		
		setVariable(executionContext, pi, getVariableName(), sb.toString());
		deleteVariable(executionContext, pi, LOOP_CURRENT_INDEX_NAME);
		deleteVariable(executionContext, pi, getCurrentIndexVariableName());
		deleteVariable(executionContext, pi, getLastIndexVariableName());
		
		saveAndSignal(executionContext, pi);
		
	}

}
