package org.spagic3.components.bpm.handler.loop;

import org.jbpm.graph.exe.ExecutionContext;

public class IndexIncrementHandler extends AbstractBaseLoopHandler {

	@Override
	public void execute(ExecutionContext executionContext) throws Exception {
		
			org.jbpm.graph.exe.ProcessInstance pi = executionContext.getToken().getProcessInstance();
			Integer currentIndex = (Integer)getVariable(executionContext, pi, getCurrentIndexVariableName());
			currentIndex += 1;
			
			
			setVariable(executionContext,pi, getCurrentIndexVariableName(), currentIndex);
			
			saveAndSignal(executionContext, pi);
			
	}

}
